#pragma once

#ifndef		X_MENU_B_H
#define		X_MENU_B_H

#include    "automat.h"

class XMenuB :
	public XAutomat
{
public:
	int m_counter;	
public:
	XMenuB(void);
	XMenuB(const char* closed, const char* waiting, int num);
	~XMenuB(void);

	void z1();
	void z2();
	void z3();
	bool x1();
};

class XStateEx :
	public XState
{
private:
	XAutomat* m_Parent;
public:
	XStateEx(void) : XState("Untitled StateEx") { m_Parent = 0;}
	XStateEx(const char* title) : XState(title) { m_Parent = 0;}
	~XStateEx(void) {}

	inline XAutomat* GetParent() {return m_Parent;}
	inline void SetParent(XAutomat* aP) {m_Parent = aP;}
};

class XMenuClosed :
	public XStateEx
{
public:
	XMenuClosed(void);
	XMenuClosed(const char*);

	~XMenuClosed(void);

	virtual int ChangeState(const XEvent &e);
	virtual void EnterInfluence();
};

class XMenuWaiting :
	public XStateEx
{
public:
	XMenuWaiting(void);
	XMenuWaiting(const char*);
	~XMenuWaiting(void);

	virtual int ChangeState(const XEvent &e);
	virtual void EnterInfluence();
};

class XMenuSelected :
	public XStateEx
{
public:
	XMenuSelected(void);
	XMenuSelected(const char*);
	~XMenuSelected(void);

	virtual int ChangeState(const XEvent &e);
	virtual void EnterInfluence();
};

class XMenuActive :
	public XStateEx
{
public:
	XMenuActive(void);
	XMenuActive(const char*);
	~XMenuActive(void);

	virtual int ChangeState(const XEvent &e);
	virtual void EnterInfluence();
};

#endif		X_MENU_B_H