#ifndef XCustomMenu_H
#define XCustomMenu_H

#include "xmenuwnd.h"

void z10(XMenuWnd* a);
void z20(XMenuWnd* a);

void z1_1();
void z1_2();
void z1_3();
void z2_1();
void z2_2();
void z2_3();

/*****************************************************************************************
** Main Menu ******************************************************************************
*****************************************************************************************/

class XCoolSub1Menu : public XMenuWnd
{
public:	
	XCoolSub1Menu();
	~XCoolSub1Menu();
};


class XCoolClosed :
	public XMenuClosed
{
public:
	XCoolClosed(void) {}
	XCoolClosed(const char* title) : XMenuClosed(title){}
	~XCoolClosed(void){}
	
	virtual int ChangeState(const XEvent &e);
	virtual void EnterInfluence();
};

class XCoolActive1 : public XMenuActive
{
public:
	XCoolActive1() {}
	XCoolActive1(const char* title) : XMenuActive(title) {}

	virtual int ChangeState(const XEvent& e);
	~XCoolActive1() {}
};

class XCoolActive2 : public XMenuActive
{
public:
	XCoolActive2() {}
	XCoolActive2(const char* title) : XMenuActive(title) {}

	virtual int ChangeState(const XEvent& e);
	~XCoolActive2() {}
};

class XCoolActive3 : public XMenuActive
{
public:
	XCoolActive3() {}
	XCoolActive3(const char* title) : XMenuActive(title) {}

	virtual int ChangeState(const XEvent& e);
	~XCoolActive3() {}
};

class XCoolSelected2 : public XMenuSelected
{
public:
	XCoolSelected2() {};
	XCoolSelected2(const char* title) : XMenuSelected(title) {}

	virtual int ChangeState(const XEvent& e);
	virtual void EnterInfluence();
	~XCoolSelected2() {}
};

/*****************************************************************************************
** Sub  Menu ******************************************************************************
*****************************************************************************************/

class XCoolSub2Menu : public XMenuWnd//XMenuB
{
public:
	XCoolSub2Menu();
	~XCoolSub2Menu();
};

class XCoolSubActive1 : public XMenuActive
{
public:
	XCoolSubActive1() {}
	XCoolSubActive1(const char* title) : XMenuActive(title) {}

	virtual int ChangeState(const XEvent& e);
	~XCoolSubActive1() {}
};

class XCoolSubActive2 : public XMenuActive
{
public:
	XCoolSubActive2() {}
	XCoolSubActive2(const char* title) : XMenuActive(title) {}

	virtual int ChangeState(const XEvent& e);
	~XCoolSubActive2() {}
};

class XCoolSubActive3 : public XMenuActive
{
public:
	XCoolSubActive3() {}
	XCoolSubActive3(const char* title) : XMenuActive(title) {}

	virtual int ChangeState(const XEvent& e);
	~XCoolSubActive3() {}
};

class XCoolSubSelected3 : public XMenuSelected
{
public:
	XCoolSubSelected3() {}
	XCoolSubSelected3(const char* title) : XMenuSelected(title) {}

	virtual int ChangeState(const XEvent& e);
	virtual void EnterInfluence();
	~XCoolSubSelected3() {}
};

/*****************************************************************************************
** Sub2 Menu ******************************************************************************
*****************************************************************************************/
class XCoolSub3Menu : public XMenuWnd
{
public:	
	XCoolSub3Menu();
	~XCoolSub3Menu();
};

class XCoolSub2Active1 : public XMenuActive
{
public:
	XCoolSub2Active1() {}
	XCoolSub2Active1(const char* title) : XMenuActive(title) {}

	virtual int ChangeState(const XEvent& e);
	~XCoolSub2Active1() {}
};

class XCoolSub2Active2 : public XMenuActive
{
public:
	XCoolSub2Active2() {}
	XCoolSub2Active2(const char* title) : XMenuActive(title) {}

	virtual int ChangeState(const XEvent& e);
	~XCoolSub2Active2() {}
};

class XCoolSub2Active3 : public XMenuActive
{
public:
	XCoolSub2Active3() {}
	XCoolSub2Active3(const char* title) : XMenuActive(title) {}

	virtual int ChangeState(const XEvent& e);
	~XCoolSub2Active3() {}
};

#endif