#include "StdAfx.h"
#include "XMenuWnd.h"

XMenuWnd::XMenuWnd(void)
{
}

XMenuWnd::~XMenuWnd(void)
{
}

BEGIN_MESSAGE_MAP(XMenuWnd, CWnd)
	ON_WM_PAINT()
END_MESSAGE_MAP()

void XMenuWnd::OnPaint()
{
	CPaintDC dc(this);

	dc.SelectObject(GetFont());

	int num = GetItemsNumber();
	
	int curr = (GetCurrentState() / 2) - 1;

	if (GetCurrentState() == 0) 
	{
		return;
	}
	int act = GetCurrentState() % 2;
	for (int i = 0; i < num; i++)
	{
		if (i == curr)
		{
			if (act == 1)
			{
				DrawSelectedItem(&dc, i);
			}
			else
			{
				DrawActiveItem(&dc, i);
			}
		}
		else
		{
			DrawDefaultItem(&dc, i);
		}
	}
}

void XMenuWnd::GetSubMenuCoordinates(int num, int& x, int& y)
{
	RECT r = GetMenuRect();
	int w = GetItemWidth();
	int h = GetItemHeight();
	int x0 = r.left;
	int y0 = r.bottom;
	if (GetDirection() == MD_HORIZONTAL)
	{
		x = x0 + num * w;
		y = y0;
	}
	else
	{
		x = x0 + w;
		y = num * h;
	}
}